rpm 5.2.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Files | Data Structures | Typedefs | Enumerations | Functions | Variables
RPMPGP.

## Files
file | rpmbc.c
file | rpmbc.h
file | rpmgc.c
file | rpmgc.h
file | rpmnss.c
file | rpmnss.h
file | rpmpgp.h
| OpenPGP constants and structures from RFC-2440.
file | rpmssl.c
file | rpmssl.h

## Data Structures
struct | pgpPktPubkey_s
| 5.1. More...
struct | pgpPktSigV3_s
| 5.2.2. More...
struct | pgpPktSigV4_s
| 5.2.3. More...
union | pgpPktSig_u
| 5.2. More...
struct | pgpPktSymkey_s
| 5.3. More...
struct | pgpPktOnepass_s
| 5.4. More...
struct | pgpPktKeyV3_s
| 5.5.1. More...
struct | pgpPktKeyV4_s
| The version 4 format is similar to the version 3 format except for the absence of a validity period. More...
union | pgpPktKey_u
| 5.5.3. More...
struct | pgpPktCdata_s
| 5.6. More...
struct | pgpPktEdata_s
| 5.7. More...
struct | pgpPktLdata_s
| 5.8. More...
struct | pgpPktTrust_s
| 5.10. More...
struct | pgpPktUid_s
| 5.11. More...
union | pgpPktPre_u

## Typedefs
typedef struct DIGEST_CTX_s * | DIGEST_CTX
typedef struct pgpPkt_s * | pgpPkt
typedef struct pgpDig_s * | pgpDig
typedef struct pgpDigParams_s * | pgpDigParams
typedef rpmuint8_t | pgpKeyID_t [8]
typedef rpmuint8_t | pgpTime_t [4]
typedef enum pgpVSFlags_e | pgpVSFlags
| Bit(s) to control digest and signature verification. More...
typedef enum pgpHashAlgo_e | pgpHashAlgo
| 9.4. More...
typedef enum rpmDigestFlags_e | rpmDigestFlags
| Bit(s) to control digest operation. More...
typedef struct rpmnss_s * | rpmnss
typedef enum pgpTag_e | pgpTag
| 4.3. More...
typedef struct pgpPktPubkey_s | pgpPktPubkey
| 5.1. More...
typedef enum pgpSigType_e | pgpSigType
| 5.2.1. More...
typedef enum pgpPubkeyAlgo_e | pgpPubkeyAlgo
| 9.1. More...
typedef enum pgpSymkeyAlgo_e | pgpSymkeyAlgo
| 9.2. More...
typedef enum pgpCompressAlgo_e | pgpCompressAlgo
| 9.3. More...
typedef struct pgpPktSigV3_s * | pgpPktSigV3
| 5.2.2. More...
typedef struct pgpPktSigV4_s * | pgpPktSigV4
| 5.2.3. More...
typedef enum pgpSubType_e | pgpSubType
| 5.2.3.1. More...
typedef union pgpPktSig_u * | pgpPktSig
| 5.2. More...
typedef struct pgpPktSymkey_s | pgpPktSymkey
| 5.3. More...
typedef struct pgpPktOnepass_s * | pgpPktOnepass
| 5.4. More...
typedef struct pgpPktKeyV3_s * | pgpPktKeyV3
| 5.5.1. More...
typedef struct pgpPktKeyV4_s * | pgpPktKeyV4
| The version 4 format is similar to the version 3 format except for the absence of a validity period. More...
typedef union pgpPktKey_u | pgpPktKey
| 5.5.3. More...
typedef struct pgpPktCdata_s | pgpPktCdata
| 5.6. More...
typedef struct pgpPktEdata_s | pgpPktEdata
| 5.7. More...
typedef struct pgpPktLdata_s | pgpPktLdata
| 5.8. More...
typedef struct pgpPktTrust_s | pgpPktTrust
| 5.10. More...
typedef struct pgpPktUid_s | pgpPktUid
| 5.11. More...
typedef enum pgpArmor_e | pgpArmor
typedef enum pgpArmorKey_e | pgpArmorKey

## Enumerations
enum | pgpVSFlags_e { RPMVSF_DEFAULT = 0, RPMVSF_NOHDRCHK = (1 << 0), RPMVSF_NEEDPAYLOAD = (1 << 1), RPMVSF_NOSHA1HEADER = (1 << 8), RPMVSF_NOMD5HEADER = (1 << 9), RPMVSF_NODSAHEADER = (1 << 10), RPMVSF_NORSAHEADER = (1 << 11), RPMVSF_NOSHA1 = (1 << 16), RPMVSF_NOMD5 = (1 << 17), RPMVSF_NODSA = (1 << 18), RPMVSF_NORSA = (1 << 19) }
| Bit(s) to control digest and signature verification. More...
enum | pgpHashAlgo_e { PGPHASHALGO_ERROR = -1, PGPHASHALGO_NONE = 0, PGPHASHALGO_MD5 = 1, PGPHASHALGO_SHA1 = 2, PGPHASHALGO_RIPEMD160 = 3, PGPHASHALGO_MD2 = 5, PGPHASHALGO_TIGER192 = 6, PGPHASHALGO_HAVAL_5_160 = 7, PGPHASHALGO_SHA256 = 8, PGPHASHALGO_SHA384 = 9, PGPHASHALGO_SHA512 = 10, PGPHASHALGO_SHA224 = 11, PGPHASHALGO_MD4 = 104, PGPHASHALGO_RIPEMD128 = 105, PGPHASHALGO_CRC32 = 106, PGPHASHALGO_ADLER32 = 107, PGPHASHALGO_CRC64 = 108, PGPHASHALGO_JLU32 = 109, PGPHASHALGO_RIPEMD256 = 111, PGPHASHALGO_RIPEMD320 = 112, PGPHASHALGO_SALSA10 = 113, PGPHASHALGO_SALSA20 = 114 }
| 9.4. More...
enum | rpmDigestFlags_e { RPMDIGEST_NONE = 0 }
| Bit(s) to control digest operation. More...
enum | pgpTag_e { PGPTAG_RESERVED = 0, PGPTAG_PUBLIC_SESSION_KEY = 1, PGPTAG_SIGNATURE = 2, PGPTAG_SYMMETRIC_SESSION_KEY = 3, PGPTAG_ONEPASS_SIGNATURE = 4, PGPTAG_SECRET_KEY = 5, PGPTAG_PUBLIC_KEY = 6, PGPTAG_SECRET_SUBKEY = 7, PGPTAG_COMPRESSED_DATA = 8, PGPTAG_SYMMETRIC_DATA = 9, PGPTAG_MARKER = 10, PGPTAG_LITERAL_DATA = 11, PGPTAG_TRUST = 12, PGPTAG_USER_ID = 13, PGPTAG_PUBLIC_SUBKEY = 14, PGPTAG_COMMENT_OLD = 16, PGPTAG_PHOTOID = 17, PGPTAG_ENCRYPTED_MDC = 18, PGPTAG_MDC = 19, PGPTAG_PRIVATE_60 = 60, PGPTAG_COMMENT = 61, PGPTAG_PRIVATE_62 = 62, PGPTAG_CONTROL = 63 }
| 4.3. More...
enum | pgpSigType_e { PGPSIGTYPE_BINARY = 0x00, PGPSIGTYPE_TEXT = 0x01, PGPSIGTYPE_STANDALONE = 0x02, PGPSIGTYPE_GENERIC_CERT = 0x10, PGPSIGTYPE_PERSONA_CERT = 0x11, PGPSIGTYPE_CASUAL_CERT = 0x12, PGPSIGTYPE_POSITIVE_CERT = 0x13, PGPSIGTYPE_SUBKEY_BINDING = 0x18, PGPSIGTYPE_SIGNED_KEY = 0x1F, PGPSIGTYPE_KEY_REVOKE = 0x20, PGPSIGTYPE_SUBKEY_REVOKE = 0x28, PGPSIGTYPE_CERT_REVOKE = 0x30, PGPSIGTYPE_TIMESTAMP = 0x40, PGPSIGTYPE_CONFIRM = 0x50 }
| 5.2.1. More...
enum | pgpPubkeyAlgo_e { PGPPUBKEYALGO_RSA = 1, PGPPUBKEYALGO_RSA_ENCRYPT = 2, PGPPUBKEYALGO_RSA_SIGN = 3, PGPPUBKEYALGO_ELGAMAL_ENCRYPT = 16, PGPPUBKEYALGO_DSA = 17, PGPPUBKEYALGO_EC = 18, PGPPUBKEYALGO_ECDSA = 19, PGPPUBKEYALGO_ELGAMAL = 20, PGPPUBKEYALGO_DH = 21 }
| 9.1. More...
enum | pgpSymkeyAlgo_e { PGPSYMKEYALGO_PLAINTEXT = 0, PGPSYMKEYALGO_IDEA = 1, PGPSYMKEYALGO_TRIPLE_DES = 2, PGPSYMKEYALGO_CAST5 = 3, PGPSYMKEYALGO_BLOWFISH = 4, PGPSYMKEYALGO_SAFER = 5, PGPSYMKEYALGO_DES_SK = 6, PGPSYMKEYALGO_AES_128 = 7, PGPSYMKEYALGO_AES_192 = 8, PGPSYMKEYALGO_AES_256 = 9, PGPSYMKEYALGO_TWOFISH = 10, PGPSYMKEYALGO_NOENCRYPT = 110 }
| 9.2. More...
enum | pgpCompressAlgo_e { PGPCOMPRESSALGO_NONE = 0, PGPCOMPRESSALGO_ZIP = 1, PGPCOMPRESSALGO_ZLIB = 2, PGPCOMPRESSALGO_BZIP2 = 3 }
| 9.3. More...
enum | pgpSubType_e { PGPSUBTYPE_NONE = 0, PGPSUBTYPE_SIG_CREATE_TIME = 2, PGPSUBTYPE_SIG_EXPIRE_TIME = 3, PGPSUBTYPE_EXPORTABLE_CERT = 4, PGPSUBTYPE_TRUST_SIG = 5, PGPSUBTYPE_REGEX = 6, PGPSUBTYPE_REVOCABLE = 7, PGPSUBTYPE_KEY_EXPIRE_TIME = 9, PGPSUBTYPE_ARR = 10, PGPSUBTYPE_PREFER_SYMKEY = 11, PGPSUBTYPE_REVOKE_KEY = 12, PGPSUBTYPE_ISSUER_KEYID = 16, PGPSUBTYPE_NOTATION = 20, PGPSUBTYPE_PREFER_HASH = 21, PGPSUBTYPE_PREFER_COMPRESS = 22, PGPSUBTYPE_KEYSERVER_PREFERS = 23, PGPSUBTYPE_PREFER_KEYSERVER = 24, PGPSUBTYPE_PRIMARY_USERID = 25, PGPSUBTYPE_POLICY_URL = 26, PGPSUBTYPE_KEY_FLAGS = 27, PGPSUBTYPE_SIGNER_USERID = 28, PGPSUBTYPE_REVOKE_REASON = 29, PGPSUBTYPE_FEATURES = 30, PGPSUBTYPE_SIG_TARGET = 31, PGPSUBTYPE_EMBEDDED_SIG = 32, PGPSUBTYPE_INTERNAL_100 = 100, PGPSUBTYPE_INTERNAL_101 = 101, PGPSUBTYPE_INTERNAL_102 = 102, PGPSUBTYPE_INTERNAL_103 = 103, PGPSUBTYPE_INTERNAL_104 = 104, PGPSUBTYPE_INTERNAL_105 = 105, PGPSUBTYPE_INTERNAL_106 = 106, PGPSUBTYPE_INTERNAL_107 = 107, PGPSUBTYPE_INTERNAL_108 = 108, PGPSUBTYPE_INTERNAL_109 = 109, PGPSUBTYPE_INTERNAL_110 = 110, PGPSUBTYPE_CRITICAL = 128 }
| 5.2.3.1. More...
enum | pgpArmor_e { PGPARMOR_ERR_CRC_CHECK = -7, PGPARMOR_ERR_BODY_DECODE = -6, PGPARMOR_ERR_CRC_DECODE = -5, PGPARMOR_ERR_NO_END_PGP = -4, PGPARMOR_ERR_UNKNOWN_PREAMBLE_TAG = -3, PGPARMOR_ERR_UNKNOWN_ARMOR_TYPE = -2, PGPARMOR_ERR_NO_BEGIN_PGP = -1, PGPARMOR_NONE = 0, PGPARMOR_MESSAGE = 1, PGPARMOR_PUBKEY = 2, PGPARMOR_SIGNATURE = 3, PGPARMOR_SIGNED_MESSAGE = 4, PGPARMOR_FILE = 5, PGPARMOR_PRIVKEY = 6, PGPARMOR_SECKEY = 7 }
enum | pgpArmorKey_e { PGPARMORKEY_VERSION = 1, PGPARMORKEY_COMMENT = 2, PGPARMORKEY_MESSAGEID = 3, PGPARMORKEY_HASH = 4, PGPARMORKEY_CHARSET = 5 }

## Functions
pgpHashAlgo | rpmDigestAlgo (DIGEST_CTX ctx)
| Return digest algorithm identifier. More...
const char * | rpmDigestName (DIGEST_CTX ctx)
| Return digest name. More...
const char * | rpmDigestASN1 (DIGEST_CTX ctx)
| Return digest ASN1 oid string. More...
DIGEST_CTX | rpmDigestDup (DIGEST_CTX octx)
| Duplicate a digest context. More...
DIGEST_CTX | rpmDigestInit (pgpHashAlgo hashalgo, rpmDigestFlags flags)
| Initialize digest. More...
int | rpmDigestUpdate (DIGEST_CTX ctx, const void *data, size_t len)
| Update context with next plain text buffer. More...
int | rpmDigestFinal (DIGEST_CTX ctx, void *datap, size_t *lenp, int asAscii)
| Return digest and destroy context. More...
static unsigned int | pgpGrab (const rpmuint8_t *s, size_t nbytes)
| Return (native-endian) integer from big-endian representation. More...
static unsigned int | pgpLen (const rpmuint8_t *s, unsigned int *lenp)
| Return length of an OpenPGP packet. More...
static unsigned int | pgpMpiBits (const rpmuint8_t *p)
| Return no. More...
static unsigned int | pgpMpiLen (const rpmuint8_t *p)
| Return no. More...
static char * | pgpHexCvt (char *t, const rpmuint8_t *s, size_t nbytes)
| Convert to hex. More...
static char * | pgpHexStr (const rpmuint8_t *p, size_t plen)
| Return hex formatted representation of bytes. More...
static const char * | pgpMpiStr (const rpmuint8_t *p)
| Return hex formatted representation of a multiprecision integer. More...
static const char * | pgpValStr (pgpValTbl vs, rpmuint8_t val)
| Return string representation of am OpenPGP value. More...
static int | pgpValTok (pgpValTbl vs, const char *s, const char *se)
| Return value of an OpenPGP string. More...
void | pgpPrtVal (const char *pre, pgpValTbl vs, rpmuint8_t val)
| Print an OpenPGP value. More...
int | pgpPrtSubType (const rpmuint8_t *h, size_t hlen, pgpSigType sigtype)
| Print/parse an OpenPGP subtype packet. More...
int | pgpPrtSig (const pgpPkt pp)
| Print/parse an OpenPGP signature packet. More...
int | pgpPrtKey (const pgpPkt pp)
| Print/parse an OpenPGP key packet. More...
int | pgpPrtUserID (const pgpPkt pp)
| Print/parse an OpenPGP userid packet. More...
int | pgpPrtComment (const pgpPkt pp)
| Print/parse an OpenPGP comment packet. More...
int | pgpPubkeyFingerprint (const rpmuint8_t *pkt, size_t pktlen, rpmuint8_t *keyid)
| Calculate OpenPGP public key fingerprint. More...
int | pgpExtractPubkeyFingerprint (const char *b64pkt, rpmuint8_t *keyid)
| Extract OpenPGP public key fingerprint from base64 encoded packet. More...
int | pgpPktLen (const rpmuint8_t *pkt, size_t pleft, pgpPkt pp)
| Return lenth of a OpenPGP packet. More...
int | pgpPrtPkt (const rpmuint8_t *pkt, size_t pleft)
| Print/parse next OpenPGP packet. More...
int | pgpPrtPkts (const rpmuint8_t *pkts, size_t pktlen, pgpDig dig, int printing)
| Print/parse a OpenPGP packet(s). More...
pgpArmor | pgpReadPkts (const char *fn, rpmuint8_t **pkt, size_t *pktlen)
| Parse armored OpenPGP packets from a file. More...
char * | pgpArmorWrap (rpmuint8_t atype, const unsigned char *s, size_t ns)
| Wrap a OpenPGP packets in ascii armor for transport. More...
pgpHashAlgo | pgpHashAlgoStringToNumber (const char *name, size_t name_len)
| Convert a hash algorithm "foo" to the internal PGPHASHALGO_FOO number. More...
pgpDig | pgpDigUnlink (pgpDig dig, const char *msg)
| Unreference a signature parameters instance. More...
pgpDig | pgpDigLink (pgpDig dig, const char *msg)
| Reference a signature parameters instance. More...
pgpDig | pgpDigFree (pgpDig dig)
| Destroy a container for parsed OpenPGP packates. More...
pgpDig | pgpDigNew (pgpVSFlags vsflags)
| Create a container for parsed OpenPGP packates. More...
void | pgpDigClean (pgpDig dig)
| Release (malloc'd) data from container. More...
pgpDigParams | pgpGetPubkey (const pgpDig dig)
| Return OpenPGP pubkey parameters. More...
pgpDigParams | pgpGetSignature (const pgpDig dig)
| Return OpenPGP signature parameters. More...
rpmuint32_t | pgpGetSigtag (const pgpDig dig)
| Get signature tag. More...
rpmuint32_t | pgpGetSigtype (const pgpDig dig)
| Get signature tag type. More...
const void * | pgpGetSig (const pgpDig dig)
| Get signature tag data, i.e. More...
rpmuint32_t | pgpGetSiglen (const pgpDig dig)
| Get signature tag data length, i.e. More...
int | pgpSetSig (pgpDig dig, rpmuint32_t sigtag, rpmuint32_t sigtype, const void *sig, rpmuint32_t siglen)
| Set signature tag info, i.e. More...
void * | pgpStatsAccumulator (pgpDig dig, int opx)
| Return pgpDig container accumulator structure. More...
int | pgpSetFindPubkey (pgpDig dig, int(*findPubkey)(void *ts, void *dig), void *_ts)
| Set find pubkey vector. More...
int | pgpFindPubkey (pgpDig dig)
| Call find pubkey vector. More...
static int | pgpIsPkt (const rpmuint8_t *p, pgpTag *tagp)
| Is buffer at beginning of an OpenPGP packet? More...
static unsigned int | pgpCRC (const rpmuint8_t *octets, size_t len)
| Return CRC of a buffer. More...

## Variables
pgpImplVecs_t | rpmnssImplVecs
struct pgpValTbl_s | pgpTagTbl []
struct pgpValTbl_s | pgpSigTypeTbl []
struct pgpValTbl_s | pgpPubkeyTbl []
struct pgpValTbl_s | pgpSymkeyTbl []
| Symmetric key (string, value) pairs. More...
struct pgpValTbl_s | pgpCompressionTbl []
| Compression (string, value) pairs. More...
struct pgpValTbl_s | pgpHashTbl []
| Hash (string, value) pairs. More...
struct pgpValTbl_s | pgpSubTypeTbl []
| Subtype (string, value) pairs. More...
struct pgpValTbl_s | pgpArmorTbl []
| Armor (string, value) pairs. More...
struct pgpValTbl_s | pgpArmorKeyTbl []
| Armor key (string, value) pairs. More...

## Detailed Description

## Typedef Documentation

typedef struct DIGEST_CTX_s* DIGEST_CTX

Definition at line 60 of file rpmiotypes.h.

typedef enum pgpArmor_e pgpArmor

typedef enum pgpArmorKey_e pgpArmorKey

typedef enum pgpCompressAlgo_e pgpCompressAlgo

9.3.

Compression Algorithms

           ID           Algorithm
           --           ---------
           0          - Uncompressed
           1          - ZIP (RFC 1951)
           2          - ZLIB (RFC 1950)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement uncompressed data. Implementations SHOULD implement ZIP. Implementations MAY implement ZLIB.

typedef struct pgpDig_s* pgpDig

Definition at line 68 of file rpmiotypes.h.

typedef struct pgpDigParams_s* pgpDigParams

Definition at line 72 of file rpmiotypes.h.

typedef enum pgpHashAlgo_e pgpHashAlgo

9.4.

Hash Algorithms

           ID           Algorithm                              Text Name
           --           ---------                              ---- ----
           1          - MD5                                    "MD5"
           2          - SHA-1                                  "SHA1"
           3          - RIPE-MD/160                            "RIPEMD160"
           4          - Reserved for double-width SHA (experimental)
           5          - MD2                                    "MD2"
           6          - Reserved for TIGER/192                 "TIGER192"
           7          - Reserved for HAVAL (5 pass, 160-bit)   "HAVAL-5-160"
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement SHA-1. Implementations SHOULD implement MD5.

Todo:
  Add SHA256.

typedef rpmuint8_t pgpKeyID_t[8]

Definition at line 76 of file rpmiotypes.h.

typedef struct pgpPkt_s* pgpPkt

Definition at line 64 of file rpmiotypes.h.

typedef struct pgpPktCdata_s pgpPktCdata

5.6.

Compressed Data Packet (Tag 8)

The Compressed Data packet contains compressed data. Typically, this packet is found as the contents of an encrypted packet, or following a Signature or One-Pass Signature packet, and contains literal data packets.

The body of this packet consists of:

- One octet that gives the algorithm used to compress the packet.
- The remainder of the packet is compressed data.

A Compressed Data Packet's body contains an block that compresses some set of packets. See section "Packet Composition" for details on how messages are formed.

ZIP-compressed packets are compressed with raw RFC 1951 DEFLATE blocks. Note that PGP V2.6 uses 13 bits of compression. If an implementation uses more bits of compression, PGP V2.6 cannot decompress it.

ZLIB-compressed packets are compressed with RFC 1950 ZLIB-style blocks.

typedef struct pgpPktEdata_s pgpPktEdata

5.7.

Symmetrically Encrypted Data Packet (Tag 9)

The Symmetrically Encrypted Data packet contains data encrypted with a symmetric-key algorithm. When it has been decrypted, it will typically contain other packets (often literal data packets or compressed data packets).

The body of this packet consists of:

- Encrypted data, the output of the selected symmetric-key cipher operating in PGP's variant of Cipher Feedback (CFB) mode.

The symmetric cipher used may be specified in an Public-Key or Symmetric-Key Encrypted Session Key packet that precedes the Symmetrically Encrypted Data Packet. In that case, the cipher algorithm octet is prefixed to the session key before it is encrypted. If no packets of these types precede the encrypted data, the IDEA algorithm is used with the session key calculated as the MD5 hash of the passphrase.

The data is encrypted in CFB mode, with a CFB shift size equal to the cipher's block size. The Initial Vector (IV) is specified as all zeros. Instead of using an IV, OpenPGP prefixes a 10-octet string to the data before it is encrypted. The first eight octets are random, and the 9th and 10th octets are copies of the 7th and 8th octets, respectively. After encrypting the first 10 octets, the CFB state is resynchronized if the cipher block size is 8 octets or less. The last 8 octets of ciphertext are passed through the cipher and the block boundary is reset.

The repetition of 16 bits in the 80 bits of random data prefixed to the message allows the receiver to immediately check whether the session key is incorrect.

typedef union pgpPktKey_u pgpPktKey

5.5.3.

Secret Key Packet Formats

The Secret Key and Secret Subkey packets contain all the data of the Public Key and Public Subkey packets, with additional algorithm- specific secret key data appended, in encrypted form.

The packet contains:

- A Public Key or Public Subkey packet, as described above
- One octet indicating string-to-key usage conventions. 0 indicates that the secret key data is not encrypted. 255 indicates that a string-to-key specifier is being given. Any other value is a symmetric-key encryption algorithm specifier.
- [Optional] If string-to-key usage octet was 255, a one-octet symmetric encryption algorithm.
- [Optional] If string-to-key usage octet was 255, a string-to-key specifier. The length of the string-to-key specifier is implied by its type, as described above.
- [Optional] If secret data is encrypted, eight-octet Initial Vector (IV).
- Encrypted multi-precision integers comprising the secret key data. These algorithm-specific fields are as described below.

- Two-octet checksum of the plaintext of the algorithm-specific portion (sum of all octets, mod 65536).

  Algorithm Specific Fields for RSA secret keys:

  - multiprecision integer (MPI) of RSA secret exponent d.
  - MPI of RSA secret prime value p.
  - MPI of RSA secret prime value q (p < q).
  - MPI of u, the multiplicative inverse of p, mod q.

  Algorithm Specific Fields for DSA secret keys:

  - MPI of DSA secret exponent x.

  Algorithm Specific Fields for Elgamal secret keys:

  - MPI of Elgamal secret exponent x.

Secret MPI values can be encrypted using a passphrase. If a string- to-key specifier is given, that describes the algorithm for converting the passphrase to a key, else a simple MD5 hash of the passphrase is used. Implementations SHOULD use a string-to-key specifier; the simple hash is for backward compatibility. The cipher for encrypting the MPIs is specified in the secret key packet.

Encryption/decryption of the secret data is done in CFB mode using the key created from the passphrase and the Initial Vector from the packet. A different mode is used with V3 keys (which are only RSA) than with other key formats. With V3 keys, the MPI bit count prefix (i.e., the first two octets) is not encrypted. Only the MPI non- prefix data is encrypted. Furthermore, the CFB state is resynchronized at the beginning of each new MPI value, so that the CFB block boundary is aligned with the start of the MPI data.

With V4 keys, a simpler method is used. All secret MPI values are encrypted in CFB mode, including the MPI bitcount prefix.

The 16-bit checksum that follows the algorithm-specific portion is the algebraic sum, mod 65536, of the plaintext of all the algorithm- specific octets (including MPI prefix and data). With V3 keys, the checksum is stored in the clear. With V4 keys, the checksum is encrypted like the algorithm-specific data. This value is used to check that the passphrase was correct.

typedef struct pgpPktKeyV3_s * pgpPktKeyV3

5.5.1.

Key Packet Variants

5.5.1.1. Public Key Packet (Tag 6)

A Public Key packet starts a series of packets that forms an OpenPGP key (sometimes called an OpenPGP certificate).

5.5.1.2. Public Subkey Packet (Tag 14)

A Public Subkey packet (tag 14) has exactly the same format as a Public Key packet, but denotes a subkey. One or more subkeys may be associated with a top-level key. By convention, the top-level key provides signature services, and the subkeys provide encryption services.

Note: in PGP 2.6.x, tag 14 was intended to indicate a comment packet. This tag was selected for reuse because no previous version of PGP ever emitted comment packets but they did properly ignore them. Public Subkey packets are ignored by PGP 2.6.x and do not cause it to fail, providing a limited degree of backward compatibility.

5.5.1.3. Secret Key Packet (Tag 5)

A Secret Key packet contains all the information that is found in a Public Key packet, including the public key material, but also includes the secret key material after all the public key fields.

5.5.1.4. Secret Subkey Packet (Tag 7)

A Secret Subkey packet (tag 7) is the subkey analog of the Secret Key packet, and has exactly the same format.

5.5.2. Public Key Packet Formats

There are two versions of key-material packets. Version 3 packets were first generated by PGP 2.6. Version 2 packets are identical in format to Version 3 packets, but are generated by PGP 2.5 or before. V2 packets are deprecated and they MUST NOT be generated. PGP 5.0 introduced version 4 packets, with new fields and semantics. PGP 2.6.x will not accept key-material packets with versions greater than 3.

OpenPGP implementations SHOULD create keys with version 4 format. An implementation MAY generate a V3 key to ensure interoperability with old software; note, however, that V4 keys correct some security deficiencies in V3 keys. These deficiencies are described below. An implementation MUST NOT create a V3 key with a public key algorithm other than RSA.

A version 3 public key or public subkey packet contains:

- A one-octet version number (3).
- A four-octet number denoting the time that the key was created.
- A two-octet number denoting the time in days that this key is valid. If this number is zero, then it does not expire.
- A one-octet number denoting the public key algorithm of this key
- A series of multi-precision integers comprising the key material:
  - a multiprecision integer (MPI) of RSA public modulus n;
  - an MPI of RSA public encryption exponent e.

V3 keys SHOULD only be used for backward compatibility because of three weaknesses in them. First, it is relatively easy to construct a V3 key that has the same key ID as any other key because the key ID is simply the low 64 bits of the public modulus. Secondly, because the fingerprint of a V3 key hashes the key material, but not its length, which increases the opportunity for fingerprint collisions. Third, there are minor weaknesses in the MD5 hash algorithm that make developers prefer other algorithms. See below for a fuller discussion of key IDs and fingerprints.

typedef struct pgpPktKeyV4_s * pgpPktKeyV4

The version 4 format is similar to the version 3 format except for the absence of a validity period.

This has been moved to the signature packet. In addition, fingerprints of version 4 keys are calculated differently from version 3 keys, as described in section "Enhanced Key Formats."

A version 4 packet contains:

- A one-octet version number (4).
- A four-octet number denoting the time that the key was created.
- A one-octet number denoting the public key algorithm of this key

- A series of multi-precision integers comprising the key material. This algorithm-specific portion is:

  Algorithm Specific Fields for RSA public keys:

  - multiprecision integer (MPI) of RSA public modulus n;
  - MPI of RSA public encryption exponent e.

  Algorithm Specific Fields for DSA public keys:

  - MPI of DSA prime p;
  - MPI of DSA group order q (q is a prime divisor of p-1);
  - MPI of DSA group generator g;
  - MPI of DSA public key value y (= g**x where x is secret).

  Algorithm Specific Fields for Elgamal public keys:

  - MPI of Elgamal prime p;
  - MPI of Elgamal group generator g;
  - MPI of Elgamal public key value y (= g**x where x is secret).

typedef struct pgpPktLdata_s pgpPktLdata

5.8.

Marker Packet (Obsolete Literal Packet) (Tag 10)

An experimental version of PGP used this packet as the Literal packet, but no released version of PGP generated Literal packets with this tag. With PGP 5.x, this packet has been re-assigned and is reserved for use as the Marker packet.

The body of this packet consists of:

- The three octets 0x50, 0x47, 0x50 (which spell "PGP" in UTF-8).

Such a packet MUST be ignored when received. It may be placed at the beginning of a message that uses features not available in PGP 2.6.x in order to cause that version to report that newer software is necessary to process the message.

typedef struct pgpPktOnepass_s * pgpPktOnepass

5.4.

One-Pass Signature Packets (Tag 4)

The One-Pass Signature packet precedes the signed data and contains enough information to allow the receiver to begin calculating any hashes needed to verify the signature. It allows the Signature Packet to be placed at the end of the message, so that the signer can compute the entire signed message in one pass.

A One-Pass Signature does not interoperate with PGP 2.6.x or earlier.

The body of this packet consists of:

- A one-octet version number. The current version is 3.
- A one-octet signature type. Signature types are described in section 5.2.1.
- A one-octet number describing the hash algorithm used.
- A one-octet number describing the public key algorithm used.
- An eight-octet number holding the key ID of the signing key.
- A one-octet number holding a flag showing whether the signature is nested. A zero value indicates that the next packet is another One-Pass Signature packet that describes another signature to be applied to the same message data.

Note that if a message contains more than one one-pass signature, then the signature packets bracket the message; that is, the first signature packet after the message corresponds to the last one-pass packet and the final signature packet corresponds to the first one- pass packet.

typedef struct pgpPktPubkey_s pgpPktPubkey

5.1.

Public-Key Encrypted Session Key Packets (Tag 1)

A Public-Key Encrypted Session Key packet holds the session key used to encrypt a message. Zero or more Encrypted Session Key packets (either Public-Key or Symmetric-Key) may precede a Symmetrically Encrypted Data Packet, which holds an encrypted message. The message is encrypted with the session key, and the session key is itself encrypted and stored in the Encrypted Session Key packet(s). The Symmetrically Encrypted Data Packet is preceded by one Public-Key Encrypted Session Key packet for each OpenPGP key to which the message is encrypted. The recipient of the message finds a session key that is encrypted to their public key, decrypts the session key, and then uses the session key to decrypt the message.

The body of this packet consists of:

- A one-octet number giving the version number of the packet type. The currently defined value for packet version is 3. An implementation should accept, but not generate a version of 2, which is equivalent to V3 in all other respects.
- An eight-octet number that gives the key ID of the public key that the session key is encrypted to.
- A one-octet number giving the public key algorithm used.
- A string of octets that is the encrypted session key. This string takes up the remainder of the packet, and its contents are dependent on the public key algorithm used.

Algorithm Specific Fields for RSA encryption

- multiprecision integer (MPI) of RSA encrypted value m**e mod n.

Algorithm Specific Fields for Elgamal encryption:

- MPI of Elgamal (Diffie-Hellman) value g**k mod p.
- MPI of Elgamal (Diffie-Hellman) value m * y**k mod p.

typedef union pgpPktSig_u * pgpPktSig

5.2.

Signature Packet (Tag 2)

A signature packet describes a binding between some public key and some data. The most common signatures are a signature of a file or a block of text, and a signature that is a certification of a user ID.

Two versions of signature packets are defined. Version 3 provides basic signature information, while version 4 provides an expandable format with subpackets that can specify more information about the signature. PGP 2.6.x only accepts version 3 signatures.

Implementations MUST accept V3 signatures. Implementations SHOULD generate V4 signatures. Implementations MAY generate a V3 signature that can be verified by PGP 2.6.x.

Note that if an implementation is creating an encrypted and signed message that is encrypted to a V3 key, it is reasonable to create a V3 signature.

typedef struct pgpPktSigV3_s * pgpPktSigV3

5.2.2.

Version 3 Signature Packet Format

The body of a version 3 Signature Packet contains:

- One-octet version number (3).
- One-octet length of following hashed material. MUST be 5.
  - One-octet signature type.
  - Four-octet creation time.
- Eight-octet key ID of signer.
- One-octet public key algorithm.
- One-octet hash algorithm.
- Two-octet field holding left 16 bits of signed hash value.
- One or more multi-precision integers comprising the signature.

Algorithm Specific Fields for RSA signatures:

- multiprecision integer (MPI) of RSA signature value m**d.

Algorithm Specific Fields for DSA signatures:

- MPI of DSA value r.
- MPI of DSA value s.

typedef struct pgpPktSigV4_s * pgpPktSigV4

5.2.3.

Version 4 Signature Packet Format

The body of a version 4 Signature Packet contains:

- One-octet version number (4).
- One-octet signature type.
- One-octet public key algorithm.
- One-octet hash algorithm.
- Two-octet scalar octet count for following hashed subpacket data. Note that this is the length in octets of all of the hashed subpackets; a pointer incremented by this number will skip over the hashed subpackets.
- Hashed subpacket data. (zero or more subpackets)
- Two-octet scalar octet count for following unhashed subpacket data. Note that this is the length in octets of all of the unhashed subpackets; a pointer incremented by this number will skip over the unhashed subpackets.
- Unhashed subpacket data. (zero or more subpackets)
- Two-octet field holding left 16 bits of signed hash value.
- One or more multi-precision integers comprising the signature.

typedef struct pgpPktSymkey_s pgpPktSymkey

5.3.

Symmetric-Key Encrypted Session-Key Packets (Tag 3)

The Symmetric-Key Encrypted Session Key packet holds the symmetric- key encryption of a session key used to encrypt a message. Zero or more Encrypted Session Key packets and/or Symmetric-Key Encrypted Session Key packets may precede a Symmetrically Encrypted Data Packet that holds an encrypted message. The message is encrypted with a session key, and the session key is itself encrypted and stored in the Encrypted Session Key packet or the Symmetric-Key Encrypted Session Key packet.

If the Symmetrically Encrypted Data Packet is preceded by one or more Symmetric-Key Encrypted Session Key packets, each specifies a passphrase that may be used to decrypt the message. This allows a message to be encrypted to a number of public keys, and also to one or more pass phrases. This packet type is new, and is not generated by PGP 2.x or PGP 5.0.

The body of this packet consists of:

- A one-octet version number. The only currently defined version is 4.
- A one-octet number describing the symmetric algorithm used.
- A string-to-key (S2K) specifier, length as defined above.
- Optionally, the encrypted session key itself, which is decrypted with the string-to-key object.

typedef struct pgpPktTrust_s pgpPktTrust

5.10.

Trust Packet (Tag 12)

The Trust packet is used only within keyrings and is not normally exported. Trust packets contain data that record the user's specifications of which key holders are trustworthy introducers, along with other information that implementing software uses for trust information.

Trust packets SHOULD NOT be emitted to output streams that are transferred to other users, and they SHOULD be ignored on any input other than local keyring files.

typedef struct pgpPktUid_s pgpPktUid

5.11.

User ID Packet (Tag 13)

A User ID packet consists of data that is intended to represent the name and email address of the key holder. By convention, it includes an RFC 822 mail name, but there are no restrictions on its content. The packet length in the header specifies the length of the user id. If it is text, it is encoded in UTF-8.

typedef enum pgpPubkeyAlgo_e pgpPubkeyAlgo

9.1.

Public Key Algorithms

           ID           Algorithm
           --           ---------
           1          - RSA (Encrypt or Sign)
           2          - RSA Encrypt-Only
           3          - RSA Sign-Only
           16         - Elgamal (Encrypt-Only), see [ELGAMAL]
           17         - DSA (Digital Signature Standard)
           18         - Reserved for Elliptic Curve
           19         - Reserved for ECDSA
           20         - Elgamal (Encrypt or Sign)
           21         - Reserved for Diffie-Hellman (X9.42,
                        as defined for IETF-S/MIME)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement DSA for signatures, and Elgamal for encryption. Implementations SHOULD implement RSA keys. Implementations MAY implement any other algorithm.

typedef enum pgpSigType_e pgpSigType

5.2.1.

Signature Types

There are a number of possible meanings for a signature, which are specified in a signature type octet in any given signature.

typedef enum pgpSubType_e pgpSubType

5.2.3.1.

Signature Subpacket Specification

The subpacket fields consist of zero or more signature subpackets. Each set of subpackets is preceded by a two-octet scalar count of the length of the set of subpackets.

Each subpacket consists of a subpacket header and a body. The header consists of:

- the subpacket length (1, 2, or 5 octets)
- the subpacket type (1 octet) and is followed by the subpacket specific data.

The length includes the type octet but not this length. Its format is similar to the "new" format packet header lengths, but cannot have partial body lengths. That is:

           if the 1st octet <  192, then
               lengthOfLength = 1
               subpacketLen = 1st_octet

           if the 1st octet >= 192 and < 255, then
               lengthOfLength = 2
               subpacketLen = ((1st_octet - 192) << 8) + (2nd_octet) + 192

           if the 1st octet = 255, then
               lengthOfLength = 5
               subpacket length = [four-octet scalar starting at 2nd_octet]

The value of the subpacket type octet may be:

           0 = reserved
           1 = reserved
           2 = signature creation time
           3 = signature expiration time
           4 = exportable certification
           5 = trust signature
           6 = regular expression
           7 = revocable
           8 = reserved
           9 = key expiration time
           10 = placeholder for backward compatibility
           11 = preferred symmetric algorithms
           12 = revocation key
           13 = reserved
           14 = reserved
           15 = reserved
           16 = issuer key ID
           17 = reserved
           18 = reserved
           19 = reserved
           20 = notation data
           21 = preferred hash algorithms
           22 = preferred compression algorithms
           23 = key server preferences
           24 = preferred key server
           25 = primary user id
           26 = policy URL
           27 = key flags
           28 = signer's user id
           29 = reason for revocation
           30 = features
           31 = signature target
           32 = embedded signature
           100 to 110 = internal or user-defined

An implementation SHOULD ignore any subpacket of a type that it does not recognize.

Bit 7 of the subpacket type is the "critical" bit. If set, it denotes that the subpacket is one that is critical for the evaluator of the signature to recognize. If a subpacket is encountered that is marked critical but is unknown to the evaluating software, the evaluator SHOULD consider the signature to be in error.

typedef enum pgpSymkeyAlgo_e pgpSymkeyAlgo

9.2.

Symmetric Key Algorithms

           ID           Algorithm
           --           ---------
           0          - Plaintext or unencrypted data
           1          - IDEA [IDEA]
           2          - Triple-DES (DES-EDE, as per spec -
                        168 bit key derived from 192)
           3          - CAST5 (128 bit key, as per RFC 2144)
           4          - Blowfish (128 bit key, 16 rounds) [BLOWFISH]
           5          - SAFER-SK128 (13 rounds) [SAFER]
           6          - Reserved for DES/SK
           7          - AES with 128-bit key
           8          - AES with 192-bit key
           9          - AES with 256-bit key
           10         - Twofish with 256-bit key
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement Triple-DES. Implementations SHOULD implement IDEA and CAST5. Implementations MAY implement any other algorithm.

typedef enum pgpTag_e pgpTag

4.3.

Packet Tags

The packet tag denotes what type of packet the body holds. Note that old format headers can only have tags less than 16, whereas new format headers can have tags as great as 63.

typedef rpmuint8_t pgpTime_t[4]

Definition at line 80 of file rpmiotypes.h.

typedef enum pgpVSFlags_e pgpVSFlags

Bit(s) to control digest and signature verification.

typedef enum rpmDigestFlags_e rpmDigestFlags

Bit(s) to control digest operation.

typedef struct rpmnss_s* rpmnss

Definition at line 24 of file rpmnss.h.

## Enumeration Type Documentation

enum pgpArmor_e

Enumerator
PGPARMOR_ERR_CRC_CHECK |
PGPARMOR_ERR_BODY_DECODE |
PGPARMOR_ERR_CRC_DECODE |
PGPARMOR_ERR_NO_END_PGP |
PGPARMOR_ERR_UNKNOWN_PREAMBLE_TAG |
PGPARMOR_ERR_UNKNOWN_ARMOR_TYPE |
PGPARMOR_ERR_NO_BEGIN_PGP |
PGPARMOR_NONE |
PGPARMOR_MESSAGE | MESSAGE
PGPARMOR_PUBKEY | PUBLIC KEY BLOCK
PGPARMOR_SIGNATURE | SIGNATURE
PGPARMOR_SIGNED_MESSAGE | SIGNED MESSAGE
PGPARMOR_FILE | ARMORED FILE
PGPARMOR_PRIVKEY | PRIVATE KEY BLOCK
PGPARMOR_SECKEY | SECRET KEY BLOCK

Definition at line 985 of file rpmpgp.h.

enum pgpArmorKey_e

Enumerator
PGPARMORKEY_VERSION | Version:
PGPARMORKEY_COMMENT | Comment:
PGPARMORKEY_MESSAGEID | MessageID:
PGPARMORKEY_HASH | Hash:
PGPARMORKEY_CHARSET | Charset:

Definition at line 1014 of file rpmpgp.h.

enum pgpCompressAlgo_e

9.3.

Compression Algorithms

           ID           Algorithm
           --           ---------
           0          - Uncompressed
           1          - ZIP (RFC 1951)
           2          - ZLIB (RFC 1950)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement uncompressed data. Implementations SHOULD implement ZIP. Implementations MAY implement ZLIB.

Enumerator
PGPCOMPRESSALGO_NONE | Uncompressed
PGPCOMPRESSALGO_ZIP | ZIP
PGPCOMPRESSALGO_ZLIB | ZLIB
PGPCOMPRESSALGO_BZIP2 | BZIP2

Definition at line 324 of file rpmpgp.h.

enum pgpHashAlgo_e

9.4.

Hash Algorithms

           ID           Algorithm                              Text Name
           --           ---------                              ---- ----
           1          - MD5                                    "MD5"
           2          - SHA-1                                  "SHA1"
           3          - RIPE-MD/160                            "RIPEMD160"
           4          - Reserved for double-width SHA (experimental)
           5          - MD2                                    "MD2"
           6          - Reserved for TIGER/192                 "TIGER192"
           7          - Reserved for HAVAL (5 pass, 160-bit)   "HAVAL-5-160"
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement SHA-1. Implementations SHOULD implement MD5.

Todo:
  Add SHA256.

Enumerator
PGPHASHALGO_ERROR |
PGPHASHALGO_NONE |
PGPHASHALGO_MD5 | MD5
PGPHASHALGO_SHA1 | SHA-1
PGPHASHALGO_RIPEMD160 | RIPEMD-160
PGPHASHALGO_MD2 | MD2
PGPHASHALGO_TIGER192 | TIGER-192
PGPHASHALGO_HAVAL_5_160 | HAVAL-5-160
PGPHASHALGO_SHA256 | SHA-256
PGPHASHALGO_SHA384 | SHA-384
PGPHASHALGO_SHA512 | SHA-512
PGPHASHALGO_SHA224 | SHA-224
PGPHASHALGO_MD4 | (private) MD4
PGPHASHALGO_RIPEMD128 | (private) RIPEMD-128
PGPHASHALGO_CRC32 | (private) CRC-32
PGPHASHALGO_ADLER32 | (private) ADLER-32
PGPHASHALGO_CRC64 | (private) CRC-64
PGPHASHALGO_JLU32 | (private) Jenkins lookup3.c
PGPHASHALGO_RIPEMD256 | (private) RIPEMD-256
PGPHASHALGO_RIPEMD320 | (private) RIPEMD-320
PGPHASHALGO_SALSA10 | (private) SALSA-10
PGPHASHALGO_SALSA20 | (private) SALSA-20

Definition at line 177 of file rpmiotypes.h.

enum pgpPubkeyAlgo_e

9.1.

Public Key Algorithms

           ID           Algorithm
           --           ---------
           1          - RSA (Encrypt or Sign)
           2          - RSA Encrypt-Only
           3          - RSA Sign-Only
           16         - Elgamal (Encrypt-Only), see [ELGAMAL]
           17         - DSA (Digital Signature Standard)
           18         - Reserved for Elliptic Curve
           19         - Reserved for ECDSA
           20         - Elgamal (Encrypt or Sign)
           21         - Reserved for Diffie-Hellman (X9.42,
                        as defined for IETF-S/MIME)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement DSA for signatures, and Elgamal for encryption. Implementations SHOULD implement RSA keys. Implementations MAY implement any other algorithm.

Enumerator
PGPPUBKEYALGO_RSA | RSA
PGPPUBKEYALGO_RSA_ENCRYPT | RSA(Encrypt-Only)
PGPPUBKEYALGO_RSA_SIGN | RSA(Sign-Only)
PGPPUBKEYALGO_ELGAMAL_ENCRYPT | Elgamal(Encrypt-Only)
PGPPUBKEYALGO_DSA | DSA
PGPPUBKEYALGO_EC | Elliptic Curve
PGPPUBKEYALGO_ECDSA | ECDSA
PGPPUBKEYALGO_ELGAMAL | Elgamal
PGPPUBKEYALGO_DH | Diffie-Hellman (X9.42)

Definition at line 242 of file rpmpgp.h.

enum pgpSigType_e

5.2.1.

Signature Types

There are a number of possible meanings for a signature, which are specified in a signature type octet in any given signature.

Enumerator
PGPSIGTYPE_BINARY | Binary document
PGPSIGTYPE_TEXT | Canonical text document
PGPSIGTYPE_STANDALONE | Standalone
PGPSIGTYPE_GENERIC_CERT | Generic certification of a User ID & Public Key
PGPSIGTYPE_PERSONA_CERT | Persona certification of a User ID & Public Key
PGPSIGTYPE_CASUAL_CERT | Casual certification of a User ID & Public Key
PGPSIGTYPE_POSITIVE_CERT | Positive certification of a User ID & Public Key
PGPSIGTYPE_SUBKEY_BINDING | Subkey Binding
PGPSIGTYPE_SIGNED_KEY | Signature directly on a key
PGPSIGTYPE_KEY_REVOKE | Key revocation
PGPSIGTYPE_SUBKEY_REVOKE | Subkey revocation
PGPSIGTYPE_CERT_REVOKE | Certification revocation
PGPSIGTYPE_TIMESTAMP | Timestamp
PGPSIGTYPE_CONFIRM | Third-Party confirmation

Definition at line 191 of file rpmpgp.h.

enum pgpSubType_e

5.2.3.1.

Signature Subpacket Specification

The subpacket fields consist of zero or more signature subpackets. Each set of subpackets is preceded by a two-octet scalar count of the length of the set of subpackets.

Each subpacket consists of a subpacket header and a body. The header consists of:

- the subpacket length (1, 2, or 5 octets)
- the subpacket type (1 octet) and is followed by the subpacket specific data.

The length includes the type octet but not this length. Its format is similar to the "new" format packet header lengths, but cannot have partial body lengths. That is:

           if the 1st octet <  192, then
               lengthOfLength = 1
               subpacketLen = 1st_octet

           if the 1st octet >= 192 and < 255, then
               lengthOfLength = 2
               subpacketLen = ((1st_octet - 192) << 8) + (2nd_octet) + 192

           if the 1st octet = 255, then
               lengthOfLength = 5
               subpacket length = [four-octet scalar starting at 2nd_octet]

The value of the subpacket type octet may be:

           0 = reserved
           1 = reserved
           2 = signature creation time
           3 = signature expiration time
           4 = exportable certification
           5 = trust signature
           6 = regular expression
           7 = revocable
           8 = reserved
           9 = key expiration time
           10 = placeholder for backward compatibility
           11 = preferred symmetric algorithms
           12 = revocation key
           13 = reserved
           14 = reserved
           15 = reserved
           16 = issuer key ID
           17 = reserved
           18 = reserved
           19 = reserved
           20 = notation data
           21 = preferred hash algorithms
           22 = preferred compression algorithms
           23 = key server preferences
           24 = preferred key server
           25 = primary user id
           26 = policy URL
           27 = key flags
           28 = signer's user id
           29 = reason for revocation
           30 = features
           31 = signature target
           32 = embedded signature
           100 to 110 = internal or user-defined

An implementation SHOULD ignore any subpacket of a type that it does not recognize.

Bit 7 of the subpacket type is the "critical" bit. If set, it denotes that the subpacket is one that is critical for the evaluator of the signature to recognize. If a subpacket is encountered that is marked critical but is unknown to the evaluating software, the evaluator SHOULD consider the signature to be in error.

Enumerator
PGPSUBTYPE_NONE | none
PGPSUBTYPE_SIG_CREATE_TIME | signature creation time
PGPSUBTYPE_SIG_EXPIRE_TIME | signature expiration time
PGPSUBTYPE_EXPORTABLE_CERT | exportable certification
PGPSUBTYPE_TRUST_SIG | trust signature
PGPSUBTYPE_REGEX | regular expression
PGPSUBTYPE_REVOCABLE | revocable
PGPSUBTYPE_KEY_EXPIRE_TIME | key expiration time
PGPSUBTYPE_ARR | additional recipient request
PGPSUBTYPE_PREFER_SYMKEY | preferred symmetric algorithms
PGPSUBTYPE_REVOKE_KEY | revocation key
PGPSUBTYPE_ISSUER_KEYID | issuer key ID
PGPSUBTYPE_NOTATION | notation data
PGPSUBTYPE_PREFER_HASH | preferred hash algorithms
PGPSUBTYPE_PREFER_COMPRESS | preferred compression algorithms
PGPSUBTYPE_KEYSERVER_PREFERS | key server preferences
PGPSUBTYPE_PREFER_KEYSERVER | preferred key server
PGPSUBTYPE_PRIMARY_USERID | primary user id
PGPSUBTYPE_POLICY_URL | policy URL
PGPSUBTYPE_KEY_FLAGS | key flags
PGPSUBTYPE_SIGNER_USERID | signer's user id
PGPSUBTYPE_REVOKE_REASON | reason for revocation
PGPSUBTYPE_FEATURES | feature flags
PGPSUBTYPE_SIG_TARGET | signature target
PGPSUBTYPE_EMBEDDED_SIG | embedded signature
PGPSUBTYPE_INTERNAL_100 | internal or user-defined
PGPSUBTYPE_INTERNAL_101 | internal or user-defined
PGPSUBTYPE_INTERNAL_102 | internal or user-defined
PGPSUBTYPE_INTERNAL_103 | internal or user-defined
PGPSUBTYPE_INTERNAL_104 | internal or user-defined
PGPSUBTYPE_INTERNAL_105 | internal or user-defined
PGPSUBTYPE_INTERNAL_106 | internal or user-defined
PGPSUBTYPE_INTERNAL_107 | internal or user-defined
PGPSUBTYPE_INTERNAL_108 | internal or user-defined
PGPSUBTYPE_INTERNAL_109 | internal or user-defined
PGPSUBTYPE_INTERNAL_110 | internal or user-defined
PGPSUBTYPE_CRITICAL | critical subpacket marker

Definition at line 484 of file rpmpgp.h.

enum pgpSymkeyAlgo_e

9.2.

Symmetric Key Algorithms

           ID           Algorithm
           --           ---------
           0          - Plaintext or unencrypted data
           1          - IDEA [IDEA]
           2          - Triple-DES (DES-EDE, as per spec -
                        168 bit key derived from 192)
           3          - CAST5 (128 bit key, as per RFC 2144)
           4          - Blowfish (128 bit key, 16 rounds) [BLOWFISH]
           5          - SAFER-SK128 (13 rounds) [SAFER]
           6          - Reserved for DES/SK
           7          - AES with 128-bit key
           8          - AES with 192-bit key
           9          - AES with 256-bit key
           10         - Twofish with 256-bit key
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement Triple-DES. Implementations SHOULD implement IDEA and CAST5. Implementations MAY implement any other algorithm.

Enumerator
PGPSYMKEYALGO_PLAINTEXT | Plaintext
PGPSYMKEYALGO_IDEA | IDEA
PGPSYMKEYALGO_TRIPLE_DES | 3DES
PGPSYMKEYALGO_CAST5 | CAST5
PGPSYMKEYALGO_BLOWFISH | BLOWFISH
PGPSYMKEYALGO_SAFER | SAFER
PGPSYMKEYALGO_DES_SK | DES/SK
PGPSYMKEYALGO_AES_128 | AES(128-bit key)
PGPSYMKEYALGO_AES_192 | AES(192-bit key)
PGPSYMKEYALGO_AES_256 | AES(256-bit key)
PGPSYMKEYALGO_TWOFISH | TWOFISH(256-bit key)
PGPSYMKEYALGO_NOENCRYPT | no encryption

Definition at line 286 of file rpmpgp.h.

enum pgpTag_e

4.3.

Packet Tags

The packet tag denotes what type of packet the body holds. Note that old format headers can only have tags less than 16, whereas new format headers can have tags as great as 63.

Enumerator
PGPTAG_RESERVED | Reserved/Invalid
PGPTAG_PUBLIC_SESSION_KEY | Public-Key Encrypted Session Key
PGPTAG_SIGNATURE | Signature
PGPTAG_SYMMETRIC_SESSION_KEY | Symmetric-Key Encrypted Session Key
PGPTAG_ONEPASS_SIGNATURE | One-Pass Signature
PGPTAG_SECRET_KEY | Secret Key
PGPTAG_PUBLIC_KEY | Public Key
PGPTAG_SECRET_SUBKEY | Secret Subkey
PGPTAG_COMPRESSED_DATA | Compressed Data
PGPTAG_SYMMETRIC_DATA | Symmetrically Encrypted Data
PGPTAG_MARKER | Marker
PGPTAG_LITERAL_DATA | Literal Data
PGPTAG_TRUST | Trust
PGPTAG_USER_ID | User ID
PGPTAG_PUBLIC_SUBKEY | Public Subkey
PGPTAG_COMMENT_OLD | Comment (from OpenPGP draft)
PGPTAG_PHOTOID | PGP's photo ID
PGPTAG_ENCRYPTED_MDC | Integrity protected encrypted data
PGPTAG_MDC | Manipulaion detection code packet
PGPTAG_PRIVATE_60 | Private or Experimental Values
PGPTAG_COMMENT | Comment
PGPTAG_PRIVATE_62 | Private or Experimental Values
PGPTAG_CONTROL | Control (GPG)

Definition at line 113 of file rpmpgp.h.

enum pgpVSFlags_e

Bit(s) to control digest and signature verification.

Enumerator
RPMVSF_DEFAULT |
RPMVSF_NOHDRCHK |
RPMVSF_NEEDPAYLOAD |
RPMVSF_NOSHA1HEADER |
RPMVSF_NOMD5HEADER |
RPMVSF_NODSAHEADER |
RPMVSF_NORSAHEADER |
RPMVSF_NOSHA1 |
RPMVSF_NOMD5 |
RPMVSF_NODSA |
RPMVSF_NORSA |

Definition at line 85 of file rpmiotypes.h.

enum rpmDigestFlags_e

Bit(s) to control digest operation.

Enumerator
RPMDIGEST_NONE |

Definition at line 208 of file rpmiotypes.h.

## Function Documentation

char* pgpArmorWrap | ( | rpmuint8_t | atype,
|  | const unsigned char * | s,
|  | size_t | ns
| ) |  |

Wrap a OpenPGP packets in ascii armor for transport.

Parameters

  atype | type of armor
  s | binary pkt data
  ns | binary pkt data length

Returns
  formatted string

Definition at line 1452 of file rpmpgp.c.

References _free(), pgpValStr(), stpcpy(), pgpValTbl_s::val, VERSION, and xmalloc().

Referenced by armorFormat(), and processMetadataFile().

static unsigned int pgpCRC | ( | const rpmuint8_t * | octets,
|  | size_t | len
| ) |  |
| inline static

Return CRC of a buffer.

Parameters

  octets | bytes
  len | no. of bytes

Returns
  crc of buffer

Definition at line 1571 of file rpmpgp.h.

References crc(), CRC24_INIT, and CRC24_POLY.

Referenced by pgpReadPkts().

void pgpDigClean | ( | pgpDig | dig | ) |

Release (malloc'd) data from container.

Parameters

  dig | signature parameters container

Definition at line 1015 of file rpmpgp.c.

References _free(), and pgpImplClean().

Referenced by pgpDigFini(), and rpmVerifySignatures().

pgpDig pgpDigFree | ( | pgpDig | dig | ) |

Destroy a container for parsed OpenPGP packates.

Parameters

  dig | signature parameters container

Returns
  NULL on last dereference

Referenced by fdFini(), fdSetDig(), getSignid(), makeGPGSignature(), pgpPrtPkts(), pgpsigFormat(), rpmcliImportPubkey(), rpmReadHeader(), rpmts_HdrCheck(), and rpmtsCleanDig().

pgpDig pgpDigLink | ( | pgpDig | dig,
|  | const char * | msg
| ) |  |

Reference a signature parameters instance.

Parameters

  dig | signature parameters
  msg |

Returns
  new signature parameters reference

Referenced by fdSetDig(), pgpDigNew(), pgpPrtPkts(), and rpmReadHeader().

pgpDig pgpDigNew | ( | pgpVSFlags | vsflags | ) |

Create a container for parsed OpenPGP packates.

Returns
  container

Definition at line 1107 of file rpmpgp.c.

References digGetPool(), pgpDigLink(), pgpDigVSFlags, and pgpImplInit().

Referenced by getSignid(), makeGPGSignature(), pgpsigFormat(), rpmcliImportPubkey(), rpmReadHeader(), rpmts_HdrCheck(), and rpmtsDig().

pgpDig pgpDigUnlink | ( | pgpDig | dig,
|  | const char * | msg
| ) |  |

Unreference a signature parameters instance.

Parameters

  dig | signature parameters
  msg |

Returns
  NULL on last dereference

int pgpExtractPubkeyFingerprint | ( | const char * | b64pkt,
|  | rpmuint8_t * | keyid
| ) |  |

Extract OpenPGP public key fingerprint from base64 encoded packet.

Todo:
  V3 non-RSA public keys not implemented.

Parameters

  b64pkt | base64 encoded openpgp packet

Return values

  keyid[8] | public key fingerprint

Returns
  8 (no. of bytes) on success, < 0 on error

Definition at line 937 of file rpmpgp.c.

References _free(), and pgpPubkeyFingerprint().

Referenced by rpmdbAdd(), and rpmdbRemove().

int pgpFindPubkey | ( | pgpDig | dig | ) |

Call find pubkey vector.

Parameters

  dig | signature parameters container

Returns
  rpmRC return code

Definition at line 1187 of file rpmpgp.c.

Referenced by rpmnsProbeSignature(), verifyDSA(), and verifyRSA().

pgpDigParams pgpGetPubkey | ( | const pgpDig | dig | ) |

Return OpenPGP pubkey parameters.

Parameters

  dig | signature parameters container

Returns
  pubkey parameters

Definition at line 1120 of file rpmpgp.c.

Referenced by rpmcliImportPubkey(), rpmnsProbeSignature(), rpmtsFindPubkey(), and rpmtsPubkey().

const void* pgpGetSig | ( | const pgpDig | dig | ) |

Get signature tag data, i.e.

from header.

Parameters

  dig | signature parameters container

Returns
  signature tag data

Definition at line 1135 of file rpmpgp.c.

Referenced by headerCheck(), pgpStashKeyid(), rpmVerifySignature(), verifyDSA(), verifyMD5(), verifyRSA(), verifySHA1(), and verifySize().

rpmuint32_t pgpGetSiglen | ( | const pgpDig | dig | ) |

Get signature tag data length, i.e.

no. of bytes of data.

Parameters

  dig | signature parameters container

Returns
  signature tag data length

Definition at line 1140 of file rpmpgp.c.

Referenced by rpmVerifySignature(), verifyDSA(), verifyMD5(), verifyRSA(), and verifySHA1().

pgpDigParams pgpGetSignature | ( | const pgpDig | dig | ) |

Return OpenPGP signature parameters.

Parameters

  dig | signature parameters container

Returns
  signature parameters

Definition at line 1115 of file rpmpgp.c.

Referenced by makeGPGSignature(), pgpsigFormat(), pgpStashKeyid(), rpmnsProbeSignature(), rpmtsFindPubkey(), rpmVerifySignatures(), verifyDSA(), and verifyRSA().

rpmuint32_t pgpGetSigtag | ( | const pgpDig | dig | ) |

Get signature tag.

Parameters

  dig | signature parameters container

Returns
  signature tag

Definition at line 1125 of file rpmpgp.c.

Referenced by rpmVerifySignature(), verifyDSA(), and verifyRSA().

rpmuint32_t pgpGetSigtype | ( | const pgpDig | dig | ) |

Get signature tag type.

Parameters

  dig | signature parameters container

Returns
  signature tag type

Definition at line 1130 of file rpmpgp.c.

static unsigned int pgpGrab | ( | const rpmuint8_t * | s,
|  | size_t | nbytes
| ) |  |
| inline static

Return (native-endian) integer from big-endian representation.

Parameters

  s | pointer to big-endian integer
  nbytes | no. of bytes

Returns
  native-endian integer

Definition at line 1041 of file rpmpgp.h.

Referenced by pgpLen(), pgpMpiStr(), pgpPktLen(), pgpPrtKey(), pgpPrtSig(), pgpPrtSubType(), pgpReadPkts(), pgpsigFormat(), pgpStashKeyid(), rpmkuFindPubkey(), rpmkuStorePubkey(), rpmnsProbeSignature(), and rpmtsFindPubkey().

pgpHashAlgo pgpHashAlgoStringToNumber | ( | const char * | name,
|  | size_t | name_len
| ) |  |

Convert a hash algorithm "foo" to the internal PGPHASHALGO_FOO number.

Parameters

  name | name of hash algorithm
  name_len | length of name or 0 for strlen(name)

Returns
  PGPHASHALGO_<name> or -1 in case of error

Definition at line 1501 of file rpmpgp.c.

References PGPHASHALGO_ERROR, pgpHashTbl, pgpValTbl_s::str, pgpValTbl_s::val, and xstrncasecmp().

Referenced by unsatisfiedDepend().

static char* pgpHexCvt | ( | char * | t,
|  | const rpmuint8_t * | s,
|  | size_t | nbytes
| ) |  |
| inline static

Convert to hex.

Parameters

  t | target buffer (returned)
  s | source bytes
  nbytes | no. of bytes

Returns
  target buffer

Definition at line 1107 of file rpmpgp.h.

Referenced by pgpHexStr(), pgpMpiHex(), pgpMpiStr(), verifyDSA(), verifyMD5(), and verifyRSA().

static char* pgpHexStr | ( | const rpmuint8_t * | p,
|  | size_t | plen
| ) |  |
| inline static

Return hex formatted representation of bytes.

Todo:
  Remove static buffer.

Parameters

  p | bytes
  plen | no. of bytes

Returns
  hex formatted string

Definition at line 1129 of file rpmpgp.h.

References pgpHexCvt().

Referenced by pgpPrtHex(), pgpPrtSig(), pgpsigFormat(), rpmcliImportPubkey(), rpmReSign(), and rpmtsFindPubkey().

static int pgpIsPkt | ( | const rpmuint8_t * | p,
|  | pgpTag * | tagp
| ) |  |
| inline static

Is buffer at beginning of an OpenPGP packet?

Parameters

  p | buffer

Return values

  *tagp | OpenPGP tag

Returns
  1 if an OpenPGP packet, 0 otherwise

Definition at line 1510 of file rpmpgp.h.

References PGPTAG_COMMENT, PGPTAG_COMMENT_OLD, PGPTAG_COMPRESSED_DATA, PGPTAG_CONTROL, PGPTAG_ENCRYPTED_MDC, PGPTAG_LITERAL_DATA, PGPTAG_MARKER, PGPTAG_MDC, PGPTAG_ONEPASS_SIGNATURE, PGPTAG_PHOTOID, PGPTAG_PRIVATE_60, PGPTAG_PRIVATE_62, PGPTAG_PUBLIC_KEY, PGPTAG_PUBLIC_SESSION_KEY, PGPTAG_PUBLIC_SUBKEY, PGPTAG_RESERVED, PGPTAG_SECRET_KEY, PGPTAG_SECRET_SUBKEY, PGPTAG_SIGNATURE, PGPTAG_SYMMETRIC_DATA, PGPTAG_SYMMETRIC_SESSION_KEY, PGPTAG_TRUST, PGPTAG_USER_ID, and pgpValTbl_s::val.

Referenced by pgpReadPkts().

static unsigned int pgpLen | ( | const rpmuint8_t * | s,
|  | unsigned int * | lenp
| ) |  |
| inline static

Return length of an OpenPGP packet.

Parameters

  s | pointer to packet

Return values

  *lenp | no. of bytes in packet

Returns
  no. of bytes in length prefix

Definition at line 1058 of file rpmpgp.h.

References pgpGrab().

Referenced by pgpPktLen(), pgpPrtSubType(), and pgpsigFormat().

static unsigned int pgpMpiBits | ( | const rpmuint8_t * | p | ) |
| inline static

Return no.

of bits in a multiprecision integer.

Parameters

  p | pointer to multiprecision integer

Returns
  no. of bits

Definition at line 1079 of file rpmpgp.h.

Referenced by pgpMpiLen(), and pgpMpiSet().

static unsigned int pgpMpiLen | ( | const rpmuint8_t * | p | ) |
| inline static

Return no.

of bytes in a multiprecision integer.

Parameters

  p | pointer to multiprecision integer

Returns
  no. of bytes

Definition at line 1092 of file rpmpgp.h.

References pgpMpiBits().

Referenced by pgpMpiHex(), pgpMpiStr(), pgpPrtPubkeyParams(), pgpPrtSeckeyParams(), pgpPrtSigParams(), and pgpPubkeyFingerprint().

static const char* pgpMpiStr | ( | const rpmuint8_t * | p | ) |
| inline static

Return hex formatted representation of a multiprecision integer.

Todo:
  Remove static buffer.

Parameters

  p | bytes

Returns
  hex formatted string

Definition at line 1145 of file rpmpgp.h.

References pgpGrab(), pgpHexCvt(), and pgpMpiLen().

Referenced by pgpPrtPubkeyParams(), pgpPrtSeckeyParams(), and pgpPrtSigParams().

int pgpPktLen | ( | const rpmuint8_t * | pkt,
|  | size_t | pleft,
|  | pgpPkt | pp
| ) |  |

Return lenth of a OpenPGP packet.

Parameters

  pkt | OpenPGP packet (i.e. PGPTAG_PUBLIC_KEY)
  pleft | OpenPGP packet length (no. of bytes)

Return values

  pp | packet tag/ptr/len

Returns
  packet length, <0 on error.

Definition at line 852 of file rpmpgp.c.

References pgpPkt_s::h, pgpPkt_s::hlen, pgpGrab(), pgpLen(), pgpPkt_s::pktlen, pgpPkt_s::tag, and pgpValTbl_s::val.

Referenced by pgpGrabPkts(), pgpPrtPkt(), pgpPrtPkts(), pgpPubkeyFingerprint(), and pgpReadPkts().

int pgpPrtComment | ( | const pgpPkt | pp | ) |

Print/parse an OpenPGP comment packet.

Parameters

  pp | packet tag/ptr/len

Returns
  0 on success

Definition at line 823 of file rpmpgp.c.

References _pgp_print, pgpPkt_s::h, pgpPkt_s::hlen, pgpPrtHex(), pgpPrtNL(), pgpPrtVal(), and pgpPkt_s::tag.

Referenced by pgpPrtPkt().

int pgpPrtKey | ( | const pgpPkt | pp | ) |

Print/parse an OpenPGP key packet.

Parameters

  pp | packet tag/ptr/len

Returns
  0 on success

Definition at line 745 of file rpmpgp.c.

References _digp, _pgp_print, pgpPkt_s::h, pgpGrab(), pgpPrtNL(), pgpPrtPubkeyParams(), pgpPrtSeckeyParams(), pgpPrtVal(), PGPTAG_PUBLIC_KEY, PGPTAG_PUBLIC_SUBKEY, pgpPktKeyV3_s::pubkey_algo, pgpPktKeyV4_s::pubkey_algo, pgpPkt_s::tag, pgpPktKeyV3_s::time, pgpPktKeyV4_s::time, pgpPktKeyV3_s::valid, pgpPktKeyV3_s::version, and pgpPktKeyV4_s::version.

Referenced by pgpPrtPkt().

int pgpPrtPkt | ( | const rpmuint8_t * | pkt,
|  | size_t | pleft
| ) |  |

Print/parse next OpenPGP packet.

Parameters

  pkt | OpenPGP packet
  pleft | no. bytes remaining

Returns
  -1 on error, otherwise this packet length

Definition at line 949 of file rpmpgp.c.

References _digp, alloca(), pgpPkt_s::h, pgpPkt_s::hlen, pgpPktLen(), pgpPrtComment(), pgpPrtHex(), pgpPrtKey(), pgpPrtNL(), pgpPrtSig(), pgpPrtUserID(), pgpPrtVal(), pgpPubkeyFingerprint(), PGPTAG_COMMENT, PGPTAG_COMMENT_OLD, PGPTAG_COMPRESSED_DATA, PGPTAG_CONTROL, PGPTAG_ENCRYPTED_MDC, PGPTAG_LITERAL_DATA, PGPTAG_MARKER, PGPTAG_MDC, PGPTAG_PHOTOID, PGPTAG_PRIVATE_60, PGPTAG_PRIVATE_62, PGPTAG_PUBLIC_KEY, PGPTAG_PUBLIC_SESSION_KEY, PGPTAG_PUBLIC_SUBKEY, PGPTAG_RESERVED, PGPTAG_SECRET_KEY, PGPTAG_SECRET_SUBKEY, PGPTAG_SIGNATURE, PGPTAG_SYMMETRIC_DATA, PGPTAG_SYMMETRIC_SESSION_KEY, PGPTAG_TRUST, PGPTAG_USER_ID, pgpPkt_s::pktlen, and pgpPkt_s::tag.

Referenced by pgpPrtPkts().

int pgpPrtPkts | ( | const rpmuint8_t * | pkts,
|  | size_t | pktlen,
|  | pgpDig | dig,
|  | int | printing
| ) |  |

Print/parse a OpenPGP packet(s).

Parameters

  pkts | OpenPGP packet(s)
  pktlen | OpenPGP packet(s) length (no. of bytes)

Return values

  dig | parsed output of signature/pubkey packet parameters

Parameters

  printing | should packets be printed?

Returns
  -1 on error, 0 on success

Definition at line 1238 of file rpmpgp.c.

References _digp, _free(), _pgp_print, alloca(), pgpDigFree(), pgpDigLink(), pgpGrabPkts(), pgpPktLen(), pgpPrtPkt(), PGPTAG_SIGNATURE, pgpPkt_s::pktlen, and pgpValTbl_s::val.

Referenced by getSignid(), headerCheck(), makeGPGSignature(), pgpsigFormat(), rpmcliImportPubkey(), rpmnsProbeSignature(), rpmReadPackageFile(), rpmts_PgpPrtPkts(), rpmtsFindPubkey(), and rpmVerifySignatures().

int pgpPrtSig | ( | const pgpPkt | pp | ) |

Print/parse an OpenPGP signature packet.

Parameters

  pp | packet tag/ptr/len

Returns
  0 on success

Definition at line 452 of file rpmpgp.c.

References _digp, _pgp_debug, _pgp_print, pgpPkt_s::h, pgpPktSigV3_s::hash_algo, pgpPktSigV4_s::hash_algo, pgpPktSigV3_s::hashlen, pgpPktSigV4_s::hashlen, pgpPkt_s::hlen, pgpGrab(), pgpHexStr(), pgpPrtHex(), pgpPrtNL(), pgpPrtSigParams(), pgpPrtSubType(), pgpPrtVal(), pgpPktSigV3_s::pubkey_algo, pgpPktSigV4_s::pubkey_algo, pgpPktSigV3_s::signhash16, pgpPktSigV3_s::signid, pgpPktSigV3_s::sigtype, pgpPktSigV4_s::sigtype, pgpPkt_s::tag, pgpPktSigV3_s::time, pgpPktSigV3_s::version, pgpPktSigV4_s::version, and xmalloc().

Referenced by pgpPrtPkt().

int pgpPrtSubType | ( | const rpmuint8_t * | h,
|  | size_t | hlen,
|  | pgpSigType | sigtype
| ) |  |

Print/parse an OpenPGP subtype packet.

Parameters

  h | packet
  hlen | packet length (no. of bytes)
  sigtype | signature type

Returns
  0 on success

Definition at line 279 of file rpmpgp.c.

References _digp, _pgp_print, pgpGrab(), pgpLen(), pgpPrtHex(), pgpPrtNL(), pgpPrtVal(), PGPSIGTYPE_BINARY, PGPSIGTYPE_POSITIVE_CERT, PGPSIGTYPE_STANDALONE, PGPSIGTYPE_TEXT, PGPSUBTYPE_ARR, PGPSUBTYPE_CRITICAL, PGPSUBTYPE_EMBEDDED_SIG, PGPSUBTYPE_EXPORTABLE_CERT, PGPSUBTYPE_FEATURES, PGPSUBTYPE_INTERNAL_100, PGPSUBTYPE_INTERNAL_101, PGPSUBTYPE_INTERNAL_102, PGPSUBTYPE_INTERNAL_103, PGPSUBTYPE_INTERNAL_104, PGPSUBTYPE_INTERNAL_105, PGPSUBTYPE_INTERNAL_106, PGPSUBTYPE_INTERNAL_107, PGPSUBTYPE_INTERNAL_108, PGPSUBTYPE_INTERNAL_109, PGPSUBTYPE_INTERNAL_110, PGPSUBTYPE_ISSUER_KEYID, PGPSUBTYPE_KEY_EXPIRE_TIME, PGPSUBTYPE_KEY_FLAGS, PGPSUBTYPE_KEYSERVER_PREFERS, PGPSUBTYPE_NOTATION, PGPSUBTYPE_POLICY_URL, PGPSUBTYPE_PREFER_COMPRESS, PGPSUBTYPE_PREFER_HASH, PGPSUBTYPE_PREFER_KEYSERVER, PGPSUBTYPE_PREFER_SYMKEY, PGPSUBTYPE_PRIMARY_USERID, PGPSUBTYPE_REGEX, PGPSUBTYPE_REVOCABLE, PGPSUBTYPE_REVOKE_KEY, PGPSUBTYPE_REVOKE_REASON, PGPSUBTYPE_SIG_CREATE_TIME, PGPSUBTYPE_SIG_EXPIRE_TIME, PGPSUBTYPE_SIG_TARGET, PGPSUBTYPE_SIGNER_USERID, and PGPSUBTYPE_TRUST_SIG.

Referenced by pgpPrtSig().

int pgpPrtUserID | ( | const pgpPkt | pp | ) |

Print/parse an OpenPGP userid packet.

Parameters

  pp | packet tag/ptr/len

Returns
  0 on success

Definition at line 806 of file rpmpgp.c.

References _digp, _free(), _pgp_print, pgpPkt_s::h, pgpPkt_s::hlen, pgpPrtNL(), pgpPrtVal(), pgpPkt_s::tag, and xmalloc().

Referenced by pgpPrtPkt().

void pgpPrtVal | ( | const char * | pre,
|  | pgpValTbl | vs,
|  | rpmuint8_t | val
| ) |  |

Print an OpenPGP value.

Parameters

  pre | output prefix
  vs | table of (string,value) pairs
  val | byte value to print

Definition at line 269 of file rpmpgp.c.

References _pgp_print, and pgpValStr().

Referenced by pgpPrtComment(), pgpPrtKey(), pgpPrtPkt(), pgpPrtSeckeyParams(), pgpPrtSig(), pgpPrtSubType(), and pgpPrtUserID().

int pgpPubkeyFingerprint | ( | const rpmuint8_t * | pkt,
|  | size_t | pktlen,
|  | rpmuint8_t * | keyid
| ) |  |

Calculate OpenPGP public key fingerprint.

Todo:
  V3 non-RSA public keys not implemented.

Parameters

  pkt | OpenPGP packet (i.e. PGPTAG_PUBLIC_KEY)
  pktlen | OpenPGP packet length (no. of bytes)

Return values

  keyid | publick key fingerprint

Returns
  0 on sucess, else -1

Definition at line 882 of file rpmpgp.c.

References _free(), alloca(), pgpPkt_s::h, PGPHASHALGO_SHA1, pgpMpiLen(), pgpPktLen(), PGPPUBKEYALGO_DSA, PGPPUBKEYALGO_RSA, PGPTAG_PUBLIC_KEY, pgpPktKeyV3_s::pubkey_algo, pgpPktKeyV4_s::pubkey_algo, RPMDIGEST_NONE, rpmDigestFinal(), rpmDigestInit(), rpmDigestUpdate(), and pgpPkt_s::tag.

Referenced by pgpExtractPubkeyFingerprint(), and pgpPrtPkt().

pgpArmor pgpReadPkts | ( | const char * | fn,
|  | rpmuint8_t ** | pkt,
|  | size_t * | pktlen
| ) |  |

Parse armored OpenPGP packets from a file.

Parameters

  fn | file name

Return values

  pkt | dearmored OpenPGP packet(s)
  pktlen | dearmored OpenPGP packet(s) length in bytes

Returns
  type of armor found

Definition at line 1282 of file rpmpgp.c.

References _free(), alloca(), crc(), PGPARMOR_ERR_BODY_DECODE, PGPARMOR_ERR_CRC_CHECK, PGPARMOR_ERR_CRC_DECODE, PGPARMOR_ERR_NO_BEGIN_PGP, PGPARMOR_ERR_NO_END_PGP, PGPARMOR_ERR_UNKNOWN_ARMOR_TYPE, PGPARMOR_FILE, PGPARMOR_MESSAGE, PGPARMOR_NONE, PGPARMOR_PRIVKEY, PGPARMOR_PUBKEY, PGPARMOR_SECKEY, PGPARMOR_SIGNATURE, PGPARMOR_SIGNED_MESSAGE, pgpCRC(), pgpGrab(), pgpIsPkt(), pgpPktLen(), PGPTAG_PUBLIC_KEY, PGPTAG_SECRET_KEY, PGPTAG_SIGNATURE, pgpValTok(), rpmiobFree(), rpmiobSlurp(), and TOKEQ.

Referenced by processMetadataFile(), rpmcliImportPubkeys(), rpmnsProbeSignature(), and rpmtsFindPubkey().

int pgpSetFindPubkey | ( | pgpDig | dig,
|  | int(*)(void *ts, void *dig) | findPubkey,
|  | void * | _ts
| ) |  |

Set find pubkey vector.

Parameters

  dig | signature parameters container
  findPubkey | routine to find a pubkey.
  _ts | argument to (*findPubkey) (ts, ...)

Returns
  0 always

Definition at line 1173 of file rpmpgp.c.

Referenced by rpmtsDig().

int pgpSetSig | ( | pgpDig | dig,
|  | rpmuint32_t | sigtag,
|  | rpmuint32_t | sigtype,
|  | const void * | sig,
|  | rpmuint32_t | siglen
| ) |  |

Set signature tag info, i.e.

from header.

Parameters

  dig | signature parameters container
  sigtag | signature tag
  sigtype | signature tag type
  sig | signature tag data
  siglen | signature tag data length

Returns
  0 always

Definition at line 1145 of file rpmpgp.c.

Referenced by headerCheck(), rpmReadPackageFile(), and rpmVerifySignatures().

void* pgpStatsAccumulator | ( | pgpDig | dig,
|  | int | opx
| ) |  |

Return pgpDig container accumulator structure.

Parameters

  dig | signature parameters container
  opx | per-container accumulator index (aka rpmtsOpX)

Returns
  per-container accumulator pointer

Definition at line 1159 of file rpmpgp.c.

Referenced by headerCheck(), rpmReadPackageFile(), rpmtsCleanDig(), verifyDSA(), verifyMD5(), verifyRSA(), and verifySHA1().

static const char* pgpValStr | ( | pgpValTbl | vs,
|  | rpmuint8_t | val
| ) |  |
| inline static

Return string representation of am OpenPGP value.

Parameters

  vs | table of (string,value) pairs
  val | byte value to lookup

Returns
  string value of byte

Definition at line 1164 of file rpmpgp.h.

References pgpValTbl_s::str, and pgpValTbl_s::val.

Referenced by pgpArmorWrap(), and pgpPrtVal().

static int pgpValTok | ( | pgpValTbl | vs,
|  | const char * | s,
|  | const char * | se
| ) |  |
| inline static

Return value of an OpenPGP string.

Parameters

  vs | table of (string,value) pairs
  s | string token to lookup
  se | end-of-string address

Returns
  byte value

Definition at line 1182 of file rpmpgp.h.

References pgpValTbl_s::str, and pgpValTbl_s::val.

Referenced by pgpReadPkts().

pgpHashAlgo rpmDigestAlgo | ( | DIGEST_CTX | ctx | ) |

Return digest algorithm identifier.

Parameters

  ctx | digest context

Returns
  digest hash algorithm identifier

Definition at line 59 of file digest.c.

References DIGEST_CTX_s::hashalgo, and PGPHASHALGO_NONE.

Referenced by rpmbcSetDSA(), rpmbcSetECDSA(), rpmbcSetRSA(), verifyDSA(), and verifyRSA().

const char* rpmDigestASN1 | ( | DIGEST_CTX | ctx | ) |

Return digest ASN1 oid string.

Values from PKCS#1 v2.1 (aka RFC-3447).

Parameters

  ctx | digest context

Returns
  digest ASN1 oid string

Definition at line 69 of file digest.c.

References DIGEST_CTX_s::asn1.

Referenced by rpmbcSetRSA().

DIGEST_CTX rpmDigestDup | ( | DIGEST_CTX | octx | ) |

Duplicate a digest context.

Parameters

  octx | existing digest context

Returns
  duplicated digest context

Definition at line 76 of file digest.c.

References DIGEST_CTX_s::param, DIGEST_CTX_s::paramsize, and xcalloc().

Referenced by verifyDSA(), verifyMD5(), verifyRSA(), and verifySHA1().

int rpmDigestFinal | ( | DIGEST_CTX | ctx,
|  | void * | datap,
|  | size_t * | lenp,
|  | int | asAscii
| ) |  |

Return digest and destroy context.

Final wrapup - pad to 64-byte boundary with the bit pattern 1 0* (64-bit count of bits processed, MSB-first)

Parameters

  ctx | digest context

Return values

  *datap | digest
  *lenp | no. bytes of digest

Parameters

  asAscii | return digest as ascii string?

Returns
  0 on success

Definition at line 412 of file digest.c.

References DIGEST_CTX_s::Digest, DIGEST_CTX_s::digestsize, DPRINTF, DIGEST_CTX_s::param, DIGEST_CTX_s::paramsize, and xmalloc().

Referenced by _tagGenerate(), digestFormat(), dodigest(), fdFini(), fdFiniDigest(), makeHDRSignature(), pgpDigFini(), pgpPubkeyFingerprint(), repoRfileDigest(), rpmbcSetDSA(), rpmbcSetECDSA(), rpmbcSetRSA(), rpmdcParseZeroInstall(), unsatisfiedDepend(), verifyMD5(), and verifySHA1().

DIGEST_CTX rpmDigestInit | ( | pgpHashAlgo | hashalgo,
|  | rpmDigestFlags | flags
| ) |  |

Initialize digest.

Set bit count to 0 and buffer to mysterious initialization constants.

Parameters

  hashalgo | type of digest
  flags | bit(s) to control digest operation

Returns
  digest context

Definition at line 85 of file digest.c.

References __adler32(), __adler32_combine(), __crc32(), __crc32_combine(), __crc64(), __crc64_combine(), DIGEST_CTX_s::asn1, sum32Param::combine, sum64Param::combine, DIGEST_CTX_s::datasize, DIGEST_CTX_s::Digest, DIGEST_CTX_s::digestsize, DPRINTF, DIGEST_CTX_s::flags, DIGEST_CTX_s::hashalgo, DIGEST_CTX_s::name, DIGEST_CTX_s::param, DIGEST_CTX_s::paramsize, PGPHASHALGO_ADLER32, PGPHASHALGO_CRC32, PGPHASHALGO_CRC64, PGPHASHALGO_HAVAL_5_160, PGPHASHALGO_JLU32, PGPHASHALGO_MD2, PGPHASHALGO_MD4, PGPHASHALGO_MD5, PGPHASHALGO_RIPEMD128, PGPHASHALGO_RIPEMD160, PGPHASHALGO_RIPEMD256, PGPHASHALGO_RIPEMD320, PGPHASHALGO_SALSA10, PGPHASHALGO_SALSA20, PGPHASHALGO_SHA1, PGPHASHALGO_SHA224, PGPHASHALGO_SHA256, PGPHASHALGO_SHA384, PGPHASHALGO_SHA512, PGPHASHALGO_TIGER192, DIGEST_CTX_s::Reset, sum32Digest(), sum32Reset(), sum32Update(), sum64Digest(), sum64Reset(), sum64Update(), sum32Param::update, sum64Param::update, DIGEST_CTX_s::Update, and xcalloc().

Referenced by _tagGenerate(), digestFormat(), dodigest(), fdInitDigest(), headerCheck(), makeHDRSignature(), pgpPubkeyFingerprint(), readFile(), repoRfileDigest(), rpmdcParseZeroInstall(), rpmnsProbeSignature(), rpmReadPackageFile(), and unsatisfiedDepend().

const char* rpmDigestName | ( | DIGEST_CTX | ctx | ) |

Return digest name.

Parameters

  ctx | digest context

Returns
  digest name

Definition at line 64 of file digest.c.

References DIGEST_CTX_s::name.

Referenced by verifyDSA(), verifyMD5(), verifyRSA(), and verifySHA1().

int rpmDigestUpdate | ( | DIGEST_CTX | ctx,
|  | const void * | data,
|  | size_t | len
| ) |  |

Update context with next plain text buffer.

Parameters

  ctx | digest context
  data | next data buffer
  len | no. bytes of data

Returns
  0 on success

Definition at line 401 of file digest.c.

References DPRINTF, DIGEST_CTX_s::param, and DIGEST_CTX_s::Update.

Referenced by _tagGenerate(), digestFormat(), dodigest(), fdUpdateDigests(), headerCheck(), makeHDRSignature(), pgpPubkeyFingerprint(), readFile(), repoRfileDigest(), rpmdcParseZeroInstall(), rpmnsProbeSignature(), rpmReadPackageFile(), unsatisfiedDepend(), verifyDSA(), and verifyRSA().

## Variable Documentation

struct pgpValTbl_s pgpArmorKeyTbl[]

Armor key (string, value) pairs.

Definition at line 222 of file rpmpgp.c.

struct pgpValTbl_s pgpArmorTbl[]

Armor (string, value) pairs.

Definition at line 211 of file rpmpgp.c.

struct pgpValTbl_s pgpCompressionTbl[]

Compression (string, value) pairs.

Definition at line 115 of file rpmpgp.c.

struct pgpValTbl_s pgpHashTbl[]

Hash (string, value) pairs.

Definition at line 123 of file rpmpgp.c.

Referenced by pgpHashAlgoStringToNumber().

struct pgpValTbl_s pgpPubkeyTbl[]

Definition at line 86 of file rpmpgp.c.

struct pgpValTbl_s pgpSigTypeTbl[]

Definition at line 68 of file rpmpgp.c.

struct pgpValTbl_s pgpSubTypeTbl[]

Subtype (string, value) pairs.

Definition at line 145 of file rpmpgp.c.

struct pgpValTbl_s pgpSymkeyTbl[]

Symmetric key (string, value) pairs.

Definition at line 99 of file rpmpgp.c.

struct pgpValTbl_s pgpTagTbl[]

Definition at line 185 of file rpmpgp.c.

pgpImplVecs_t rpmnssImplVecs

Referenced by rpmioAllArgCallback().